(function(w) {
    function plusReady() {
        console.log("plusReady");
    };
    if (w.plus) {
        plusReady();
    } else {
        document.addEventListener("plusready", plusReady, false);
    };
    //IOS跳转
    function openSafari(url) {
        plus.runtime.openURL(url);
    }
    var packName = null;
    var dtask = null;
    var dysdk = {
        checkAppInstalled: function(pg) {
            this.packName = pg;
            var b = plus.runtime.isApplicationExist({
                pname: pg
            }) ? 1 : 0;
            return b;
        },
        startApp: function(pg) {
            if (plus.os.name == "Android") {
                plus.runtime.launchApplication({
                    pname: pg
                }, function(e) {
                    alert("Open system default browser failed: " + e.message);
                });
            }
        },
        openBrowser: function(pg) { //IOS下载
            plus.runtime.openURL(pg);
        },
        downloadAndInstall: function(down_url) {
            var index = down_url.lastIndexOf('/') > down_url.lastIndexOf('?') ? down_url.lastIndexOf('/') : down_url.lastIndexOf(
                '?');
            var apk_name = "_downloads/" + down_url.substring(index + 1, down_url.length);
            if (apk_name.indexOf(".apk") == -1) {
                apk_name = apk_name + '.apk';
            }
            if (dtask != null && dtask.url === down_url) {
                return;
            }
            var options = {
                method: "GET",
                filename: apk_name
            };
            var precent = 0;
            dtask = plus.downloader.createDownload(down_url, options, null);
            dtask.addEventListener("statechanged", function(task, status) {
                if (!dtask) {
                    return;
                }
                switch (task.state) {
                    case 1: // 开始
                        precent = 0;
                        break;
                    case 2: // 已连接到服务器
                        precent = 0;
                        break;
                    case 3: // 已接收到数据
                        var cur_precent = parseInt(100 * task.downloadedSize / task.totalSize)
                        if (precent != cur_precent) {
                            precent = cur_precent;
                            onProgress(down_url, 2, precent);
                        }
                        break;
                    case 4: // 下载完成
                        var filepath = task.filename;
                        onProgress(down_url, 8, 100);
                        var install_options = {
                            force: false
                        };
                        plus.runtime.install(filepath, install_options, function(widgetInfo) {
                            dtask = null;
                        }, function(e) {
                            dtask = null;
                        });
                        break;
                }
            });
            dtask.start();
        }
    };
    w.dysdk = dysdk;
})(window);